thigh_lenght=250;
upper_sphere_thigh=[thigh_lenght,0,0]; //thigh length
upper_sphere_scale=[2.1,1.1,1]; //[2.1,1.1,1]
upper_sphere_radius=50;

back_sphere=[thigh_lenght,25,25]; //inner backside
back_sphere_scale=[2.5,1,1];
back_sphere_radius=30;

inner_thight_up=[thigh_lenght-20,8,thigh_lenght/100*8+7];
inner_thigh_low=[(thigh_lenght/2)-5,8,thigh_lenght/100*8+10];
inner_sphere_scale=[2.5,1,1];
//inner_sphere_scale=[2.5,1.2,1.1]; 
inner_sphere_radius=back_sphere_radius+2;

mid_sphere=[60,15,thigh_lenght/100*8];
mid_sphere_scale=inner_sphere_scale;   
mid_sphere_radius=30;

low_sphere=[5,10,25];
low_sphere_radius=20;
low_sphere_scale=[1,1,1.2];

thigh2_offset=[0,0,-140];
thigh2_color="red";

butt_inner_sphere=30;

$fn=50;

//left thigh
hull(){
    //  
    translate(upper_sphere_thigh)
        scale(upper_sphere_scale)
        sphere(upper_sphere_radius);   
    //
    translate(back_sphere)
        scale(back_sphere_scale)
        sphere(back_sphere_radius);
    //
    hull(){
        translate(inner_thight_up)
            scale(mid_sphere_scale)    
            sphere(inner_sphere_radius);
        //
        translate(inner_thigh_low)
            scale(inner_sphere_scale)    
            sphere(inner_sphere_radius);
    }      
    //
    translate(mid_sphere)
        scale(mid_sphere_scale)    
        sphere(mid_sphere_radius);
    //
    translate(low_sphere)
        scale(low_sphere_scale)
        sphere(low_sphere_radius); 
}


//right thigh
mirror([0,0,90]){
translate(thigh2_offset)
    hull(){
        //  
        translate(upper_sphere_thigh)
            scale(upper_sphere_scale)
            sphere(upper_sphere_radius);   
        //
        translate(back_sphere)
            scale(back_sphere_scale)
            sphere(back_sphere_radius);
        //
        hull(){    
            translate(inner_thight_up)
                scale(mid_sphere_scale)    
                sphere(inner_sphere_radius);
            //
            translate(inner_thigh_low)
                scale(inner_sphere_scale)    
                sphere(inner_sphere_radius);
        }  
        //    
        translate(mid_sphere)
            scale(mid_sphere_scale)
            sphere(mid_sphere_radius);
        //
        translate(low_sphere+[0,0,5])
            scale([1,1,1.2])
            sphere(low_sphere_radius);
        }
    }


//left buttock
hull(){
    translate(upper_sphere_thigh+[40,20,5])
        color("red")
        scale([1.5,1.2,0.95])
        sphere(upper_sphere_radius);
    //smoothing edges and inner side    
    translate(upper_sphere_thigh+[10,-5,2])
        color("blue")
        scale([1.9,0.9,0.97])
        sphere(upper_sphere_radius);
    //backside
    translate(upper_sphere_thigh+[45,35,15])
        scale([1.6,1.2,1.2])
        color("green")
        sphere(45);
    //smooting, nearly same than upper part of thigh     
    translate(upper_sphere_thigh+[30,0,0])
        scale(upper_sphere_scale-[0.8,0.2,0.1])
        sphere(upper_sphere_radius);     
    }


//right buttock
mirror([0,0,90]){
translate(thigh2_offset)    
hull(){
    translate(upper_sphere_thigh+[40,20,5])
        color("red")
        scale([1.5,1.2,0.95])
        sphere(upper_sphere_radius);
    //smoothing edges and inner side    
    translate(upper_sphere_thigh+[10,-5,2])
        color("blue")
        scale([1.9,0.9,0.97])
        sphere(upper_sphere_radius);
    //backside
    translate(upper_sphere_thigh+[45,35,15])
        scale([1.6,1.2,1.2])
        color("green")
        sphere(45);
    //smooting, nearly same than upper part of thigh     
    translate(upper_sphere_thigh+[30,0,0])
        scale(upper_sphere_scale-[0.8,0.2,0.1])
        sphere(upper_sphere_radius);     
    }
}

/*
//hips
hull(){
// side sphere left  
translate(upper_sphere_thigh+[40,20,5])
    scale([1.5,1.1,1])
    sphere(20);
translate(upper_sphere_thigh+[65,0,75])
    scale([1.5,0.8,1.5])
    color("blue")
    sphere(40);       
translate(upper_sphere_thigh+[10,10,75])
    color("blue")
    sphere(10);    
}

//belly
hull(){
translate([thigh_lenght+100,0,0])
    color("blue")
    sphere(20);        
translate([thigh_lenght+100,0,0]+[0,0,thigh_lenght/2+25])
    color("blue")
    sphere(20);
translate([thigh_lenght+100,0,0]+[30,0,thigh_lenght/2-50])
    scale([1.5,0.8,1.5])
    color("blue")
    sphere(50);
}
*/