
thigh_lenght=250;
upper_sphere_thigh=[thigh_lenght,0,0]; //thigh length
upper_sphere_scale=[2.1,1.1,1]; //[2.1,1.1,1]
upper_sphere_radius=50;

back_sphere=[thigh_lenght,25,25]; //inner backside
back_sphere_scale=[2.5,1,1];
back_sphere_radius=30;

inner_thight_up=[thigh_lenght-20,8,thigh_lenght/100*8+7];
inner_thigh_low=[(thigh_lenght/2)-5,8,thigh_lenght/100*8+10];
inner_sphere_scale=[2.5,1,1];
//inner_sphere_scale=[2.5,1.2,1.1]; 
inner_sphere_radius=back_sphere_radius+2;

mid_sphere=[60,15,thigh_lenght/100*8];
mid_sphere_scale=inner_sphere_scale;   
mid_sphere_radius=30;

low_sphere=[5,10,30];
low_sphere_radius=20;
low_sphere_scale=[1,1,1.4];

thigh2_offset=[0,0,-140];

butt_mid_sphere=upper_sphere_thigh+[40,20,5];
butt_mid_sphere_scale=[1.5,1.2,0.95];
butt_mid_sphere_rad=upper_sphere_radius-1;
//smoothing edges and inner side
butt_inner_sphere=upper_sphere_thigh+[10,-5,2];
butt_inner_sphere_scale=[1.9,0.9,0.97];
//backside
butt_back_sphere=upper_sphere_thigh+[45,35,15];
butt_back_sphere_scale=[1.6,1.2,1.2];
butt_back_sphere_rad=45;
//smooting, nearly same than upper part of thigh
butt_front_sphere=upper_sphere_thigh+[30,0,0];
butt_front_sphere_scale=upper_sphere_scale-[0.8,0.2,0.1];
butt_front_sphere_rad=upper_sphere_radius+4;

$fn=50;
final_color="pink";

//left thigh
color(final_color)
hull(){
    //  
    translate(upper_sphere_thigh)
        scale(upper_sphere_scale)
        sphere(upper_sphere_radius);   
    //
    translate(back_sphere)
        scale(back_sphere_scale)
        sphere(back_sphere_radius);
    //
    hull(){
        translate(inner_thight_up)
            scale(mid_sphere_scale)    
            sphere(inner_sphere_radius);
        //
        translate(inner_thigh_low)
            scale(inner_sphere_scale)    
            sphere(inner_sphere_radius);
    }      
    //
    translate(mid_sphere)
        scale(mid_sphere_scale)    
        sphere(mid_sphere_radius);
    //
    translate(low_sphere)
        scale(low_sphere_scale)
        sphere(low_sphere_radius); 
}


//right thigh
color(final_color)
mirror([0,0,90]){
translate(thigh2_offset)
    hull(){
        //  
        translate(upper_sphere_thigh)
            scale(upper_sphere_scale)
            sphere(upper_sphere_radius);   
        //
        translate(back_sphere)
            scale(back_sphere_scale)
            sphere(back_sphere_radius);
        //
        hull(){    
            translate(inner_thight_up)
                scale(mid_sphere_scale)    
                sphere(inner_sphere_radius);
            //
            translate(inner_thigh_low)
                scale(inner_sphere_scale)    
                sphere(inner_sphere_radius);
        }  
        //    
        translate(mid_sphere)
            scale(mid_sphere_scale)
            sphere(mid_sphere_radius);
        //
        translate(low_sphere)
            scale(low_sphere_scale)
            sphere(low_sphere_radius);
        }
    }


//left buttock
color(final_color)    
hull(){
    translate(butt_mid_sphere)
        color("red")
        scale(butt_mid_sphere_scale)
        sphere(butt_mid_sphere_rad);
    //smoothing edges and inner side    
    translate(butt_inner_sphere)
        color("blue")
        scale(butt_inner_sphere_scale)
        sphere(upper_sphere_radius);
    //backside
    translate(butt_back_sphere)
        scale(butt_back_sphere_scale)
        color("green")
        sphere(butt_back_sphere_rad);
    //smooting, nearly same than upper part of thigh     
    translate(butt_front_sphere)
        color("cyan")
        scale(butt_front_sphere_scale)
        sphere(butt_front_sphere_rad);     
}


//right buttock
color(final_color)
mirror([0,0,90]){
translate(thigh2_offset)    
hull(){
    translate(butt_mid_sphere)
        scale(butt_mid_sphere_scale)
        sphere(butt_mid_sphere_rad);   
    translate(butt_inner_sphere)
        scale(butt_inner_sphere_scale)
        sphere(upper_sphere_radius);
    translate(butt_back_sphere)
        scale(butt_back_sphere_scale)
        sphere(butt_back_sphere_rad);    
    translate(butt_front_sphere)
        scale(butt_front_sphere_scale)
        sphere(butt_front_sphere_rad);     
    }
}


//hips
color(final_color)
hull(){
// side sphere left  
translate(upper_sphere_thigh+[80,-20,0])
    color("blue")
    scale([1.5,1.1,1])
    sphere(20);
translate(upper_sphere_thigh+[80,-20,140])
    color("blue")
    scale([1.5,1.1,1])
    sphere(20); 
translate(upper_sphere_thigh+[110,-25,70])
    scale([2,0.8,1.8])
    color("red")
    sphere(40);

hull(){    
translate(upper_sphere_thigh+[35,-10,70])
    color("green")
    sphere(25);
translate(upper_sphere_thigh+[60,-30,-15])
    color("blue")
    scale([1.5,1.2,1])
    sphere(10);
translate(upper_sphere_thigh+[60,-30,155])
    color("blue")
    scale([1.5,1.2,1])
    sphere(10);      
}

}

color(final_color)
hull(){
    translate(upper_sphere_thigh+[150,-15,25])
        color("cyan")
        scale([1.5,1.1,1])
        sphere(20);
    translate(upper_sphere_thigh+[150,-15,115])
        color("cyan")
        scale([1.5,1.1,1])
        sphere(20); 
      
    //backside sphere
    translate(upper_sphere_thigh+[150,30,70])
        color("cyan")
        scale([4,1.1,1])
        sphere(30);     


//belly
 color(final_color)
//hull(){
translate([thigh_lenght+80,0,0])
    color("blue")
    sphere(20);        
translate([thigh_lenght+80,0,0]+[0,0,thigh_lenght/2+20])
    color("blue")
    sphere(20);
translate([thigh_lenght+120,0,0]+[30,0,thigh_lenght/2-55])
    scale([2.7,1,1.5])
    color("blue")
    sphere(50);
}

//lower leg
hull(){
        translate(low_sphere+[-25,5,5])
            color("green")
//            scale(low_sphere_scale+[0,-0.2,-0.2])
            sphere(low_sphere_radius+2);
    
        translate(low_sphere+[5,0,10])
            color("violet")
            scale(low_sphere_scale+[0,0,0])
            sphere(10);    
            
        translate(low_sphere+[-75,15,12])
            color("blue")
            scale([3,1,1])
            sphere(22);

       translate(low_sphere+[-140,10,12])
            color("red")
            scale([1,1,1])
            sphere(10);
}












