thigh_lenght=250;
upper_sphere=[thigh_lenght,0,0]; //thigh length
upper_sphere_scale=[2.1,1.1,1]; //[2.1,1.1,1]
upper_sphere_radius=50;

back_sphere=[thigh_lenght,25,25]; //inner backside
back_sphere_scale=[2.5,1,1];
back_sphere_radius=30;

mid_sphere=[60,15,thigh_lenght/100*8];
mid_sphere_scale=[2.5,1,1];   
mid_sphere_radius=30;

inner_sphere_scale=mid_sphere_scale;
inner_sphere=back_sphere_radius;

low_sphere=[5,10,20];
low_sphere_scale=[1,1,1.2];
low_sphere_radius=20;

thigh2_offset=[0,0,(-thigh_lenght/2)-10];
thigh2_color="red";

butt_inner_sphere=30;

$fn=50;


hull(){
//  
translate(upper_sphere)
    scale(upper_sphere_scale)
    sphere(upper_sphere_radius);   
//
translate(back_sphere)
    scale(back_sphere_scale)
    sphere(back_sphere_radius);
//
hull(){
    translate([thigh_lenght-20,8,thigh_lenght/100*8+7])
    scale(mid_sphere_scale)    
    sphere(inner_sphere+2);
//
translate([thigh_lenght-120,8,thigh_lenght/100*8+10])
     scale(mid_sphere_scale+[1.5,0.2,0.1])    
     sphere(inner_sphere);
    }      
//
translate(mid_sphere)
    scale(mid_sphere_scale)    
    sphere(mid_sphere_radius);
//
translate(low_sphere+[0,0,5])
    scale(low_sphere_scale)
    sphere(low_sphere_radius); 
}

//right thigh
mirror([0,0,90]){
translate(thigh2_offset)
    hull(){
    //  
    translate(upper_sphere)
        scale(upper_sphere_scale)
        sphere(upper_sphere_radius);   
    //
    translate(back_sphere)
        scale(back_sphere_scale)
        sphere(back_sphere_radius);
    //
    hull(){    
    translate([thigh_lenght-20,8,thigh_lenght/100*8+7])
        scale(mid_sphere_scale)    
        sphere(inner_sphere+2);
    //
       translate([thigh_lenght-120,8,thigh_lenght/100*8+10])
        scale(mid_sphere_scale+[1.5,0.2,0.1])    
        sphere(inner_sphere);}  
    //    
    translate(mid_sphere)
        scale(mid_sphere_scale)
        sphere(mid_sphere_radius);
    //
    translate(low_sphere+[0,0,5])
        scale([1,1,1.2])
        sphere(low_sphere_radius);
    }
}


hull(){
translate(upper_sphere+[40,20,5])
    color("red")
    scale([1.5,1.2,0.95])
    sphere(upper_sphere_radius);
//smoothing edges and inner side    
translate(upper_sphere+[10,-5,2])
    color("blue")
    scale([1.9,0.9,0.97])
    sphere(upper_sphere_radius);
//backside
translate(upper_sphere+[45,35,15])
    scale([1.6,1.2,1.2])
    color("green")
    sphere(45);
//smooting, nearly same than upper part of thigh     
translate(upper_sphere+[30,0,0])
    scale(upper_sphere_scale-[0.8,0.2,0.1])
    sphere(upper_sphere_radius);     
}

mirror([0,0,90]){
translate(thigh2_offset)
    hull(){
    translate(upper_sphere+[40,20,5])
        color("red")
        scale([1.5,1.2,0.95])
        sphere(upper_sphere_radius);
    //smoothing edges and inner side    
    translate(upper_sphere+[10,-5,2])
        color("blue")
        scale([1.9,0.9,0.97])
        sphere(upper_sphere_radius);
    //backside
    translate(upper_sphere+[45,35,15])
        scale([1.6,1.2,1.2])
        color("green")
        sphere(45);
    //smooting, nearly same than upper part of thigh     
    translate(upper_sphere+[30,0,0])
        scale(upper_sphere_scale-[0.8,0.2,0.1])
        sphere(upper_sphere_radius);     
    }
}