low_sphere=[5,10,30];
low_sphere_radius=20;
low_sphere_scale=[1,1,1.4];
$fn=100;

module xmirror(copy=false,condition=true){
	if(condition){
		mirror([1,0,0])
		children();
		
		if(copy){
			children();
		}
	}else{
		children();
	}
}

module ymirror(copy=false,condition=true){
	if(condition){
		mirror([0,1,0])
		children();
		
		if(copy){
			children();
		}
	}else{
		children();
	}
}

module zmirror(copy=false,condition=true){
	if(condition){
		mirror([0,0,1])
		children();
		
		if(copy){
			children();
		}
	}else{
		children();
	}
}

module xrot(v,copy=false,condition=true){
	if(condition){
		rotate([v,0,0])
		children();
		
		if(copy){
			children();
		}
	}else{
		children();
	}
}

module yrot(v,copy=false,condition=true){
	if(condition){
		rotate([0,v,0])
		children();
		
		if(copy){
			children();
		}
	}else{
		children();
	}
}

module zrot(v,copy=false,condition=true){
	if(condition){
		rotate([0,0,v])
		children();
		
		if(copy){
			children();
		}
	}else{
		children();
	}
}

module xtran(dist,copy=false,condition=true){
	if(condition){
		translate([dist,0,0])
		children();
		
		if(copy){
			children();
		}
	}else{
		children();
	}
}

module ytran(dist,copy=false,condition=true){
	if(condition){
		translate([0,dist,0])
		children();
		
		if(copy){
			children();
		}
	}else{
		children();
	}
}

module ztran(dist,copy=false,condition=true){
	if(condition){
		translate([0,0,dist])
		children();
		
		if(copy){
			children();
		}
	}else{
		children();
	}
}



module lower_leg(){
     hull(){
        translate(low_sphere+[-25,5,5])
            color("green")
//            scale(low_sphere_scale+[0,-0.2,-0.2])
            sphere(low_sphere_radius+2);
    
        translate(low_sphere+[5,0,10])
            color("violet")
            scale(low_sphere_scale+[0,0,0])
            sphere(10);    
            
        translate(low_sphere+[-75,15,12])
            color("blue")
            scale([3,1,1])
            sphere(22);

       translate(low_sphere+[-140,10,12])
            color("red")
            scale([1,1,1])
            sphere(10);
    }   
}

color("pink")
lower_leg();