$fn=200;
nose_uptick=2;
chin_sphere_size=3;
chin_position=[0,-5,9];
front_area_size=7;
front_area_scale=[1.1,1,0.5];
nose_tip_position=6;
cheeks_h_pos=11;
cheeks_v_pos=6;
cheeks_z_pos=10;
cheek_scale=[0.9,1.8,0.5];
cheek_sphere=5;
upper_middle_head_sphere=13;
upper_middle_head_scale=[1.4,1,0.8];
upper_back_head_sphere=upper_middle_head_sphere;
upper_back_head_scale=[1.4,1,1];
lower_middle_head_sphere=10; 
lower_middle_head_scale=[1.5,1,1];  
chin_cylinder_base=8;
chin_cylinder_depth=10;
chin_cylinder_top=3;

module chin_cylinder(){
    translate([0,nose_uptick,nose_tip_position])
    rotate([0,0,0])
    scale([1.7,1,1])
    cylinder(chin_cylinder_depth,chin_cylinder_top,chin_cylinder_base);
}


//head spheres
//hull(){
    //upper middle head sphere
    translate([0,10,16])
        color("red")
        scale(upper_middle_head_scale)
        sphere(upper_middle_head_sphere);

    //upper back head sphere    
    translate([0,10,20])
        color("red")
        scale(upper_back_head_scale)
        sphere(upper_back_head_sphere);    

    //lower middle head sphere    
    translate([0,2,14])
        color("green")
        scale(lower_middle_head_scale)
        sphere(lower_middle_head_sphere);

    /*//cheeks
    translate([cheeks_h_pos,cheeks_v_pos,cheeks_z_pos])
        color("yellow")
        scale(cheek_scale)
        sphere(cheek_sphere);
    translate([cheeks_h_pos*-1,cheeks_v_pos,cheeks_z_pos])
        color("yellow")
        scale(cheek_scale)
        sphere(cheek_sphere);
    */
    //sides
    translate([-14,5,14])
    color("lightblue")
    rotate([90,-15,120])
    scale([1.7,1.2,0.5])
    sphere(5); 

//}

//nose and chin
hull(){
    //chin cylinder
    color("violet")
    chin_cylinder();

    //chin sphere    
    translate(chin_position)
        sphere(chin_sphere_size); 

    //nose sphere    
    translate([0,nose_uptick,nose_tip_position])
        color("black")
        scale(front_area_scale)
        sphere(front_area_size);     
}


