$fn=200;
nose_uptick=2;
chin_sphere_size=4;
chin_position=[0,-5,11];
chin_scale=[1,1,1.3];
front_area_size=7;
front_area_scale=[1.5,0.9,0.5];
front_face_position=6.5;
cheeks_h_pos=11;
cheeks_v_pos=6;
cheeks_z_pos=10;
cheek_scale=[0.9,1.8,0.5];
cheek_sphere=5;
upper_middle_head_sphere=13;
upper_middle_head_scale=[1.4,1,0.8];
upper_back_head_sphere=upper_middle_head_sphere;
upper_back_head_scale=[1.4,1,1];
lower_middle_head_sphere=10; 
lower_middle_head_scale=[1.5,1,1];  
//chin_cylinder_base=8;
//chin_cylinder_depth=10;
//chin_cylinder_top=3;

module chin_cylinder(){
    translate([0,nose_uptick,front_face_position])
    rotate([0,0,0])
    scale([1.7,1,1])
    cylinder(chin_cylinder_depth,chin_cylinder_top,chin_cylinder_base);
}
module sides(){
    //cheeks
    translate([-14,2,13])
    color("lightblue")
    rotate([90,-15,120])
    scale([1.7,1.2,0.5])
    sphere(4); 
    
    //cheek bones
    translate([-17,7,15])
    color("white")
    rotate([80,-70,120])
    scale([2,1,0.4])
    sphere(3);
}
module eye_cavity(){
    translate([0,0,-1])
    hull(){
        translate([-11,13,9])
        //translate([-13,9,9])
        color("green")
        rotate([0,20,-10])
        scale([1.7,1.1,0.25])
        sphere(5.5);
             
        //flatter
        translate([-11,7,1])
        //translate([-13,9,9])
        color("green")
        rotate([0,0,-30])
        scale([1.7,1.1,0.25])
        sphere(5);

        //smaller
        translate([-7,12,7])
        //translate([-9,8,7])
        color("blue")
        rotate([0,0,0])
        scale([1,1,0.6])
        sphere(2.5);
    }
    }    
module eye(){
    
    difference(){
        translate([-9,10,9.5])
        color("white")
        rotate([0,20,-10])
        scale([1,1.3,0.5])
        sphere(5);
        
        translate([-9,11,6.5])
        color("white")
        rotate([0,20,-10])
        scale([1,1.1,1])
        sphere(3);
    }

        translate([-9,11,7.4])
        color("violet")
        rotate([0,15,-10])
        scale([1,1.2,0.2])
        sphere(3);

        translate([-9,10.5,6.9])
        color("black")
        rotate([0,20,-10])
        scale([1,1,0.25])
        sphere(1.25);
}

color("pink")    
difference(){
    //head spheres
    hull(){   
        //upper middle head sphere
        translate([0,10,16])
            color("red")
            scale(upper_middle_head_scale)
            sphere(upper_middle_head_sphere);

        //upper back head sphere    
        translate([0,10,20])
            color("red")
            scale(upper_back_head_scale)
            sphere(upper_back_head_sphere);    

        //lower middle head sphere    
        translate([0,2,14])
            color("green")
            scale(lower_middle_head_scale)
            sphere(lower_middle_head_sphere);

        /*
        //cheeks
        translate([cheeks_h_pos,cheeks_v_pos,cheeks_z_pos])
            color("yellow")
            scale(cheek_scale)
            sphere(cheek_sphere);
        translate([cheeks_h_pos*-1,cheeks_v_pos,cheeks_z_pos])
            color("yellow")
            scale(cheek_scale)
            sphere(cheek_sphere);
        */
        sides();
        mirror(){
            sides();
        }
        
        //chin sphere    
        translate(chin_position)
            scale(chin_scale)
            sphere(chin_sphere_size);
            

        //nose sphere    
        translate([0,nose_uptick,front_face_position])
            color("white")
            scale(front_area_scale)
            sphere(front_area_size);     

    }

    //eyes 
    eye_cavity();
    mirror(){
        eye_cavity();
        }
    
    //mouth    
    color("violet") 
    translate([0,0,3.5])  
        hull(){
        scale([1.5,1,0.5])
        sphere(2);
        translate([-2,1,0])
        scale([1.5,1,0.5])    
        sphere(1);    
        }    
}

    eye();
    mirror(){
        eye();
    }

difference(){
    color("violet") 
    translate([0,0,3.5])  
        hull(){
        scale([1.5,1,0.5])
        sphere(2);
        translate([-2,1,0])
        scale([1.5,1,0.5])    
        sphere(1);    
        }
       
    color("violet") 
    translate([0,0,3.5])  
        hull(){
        scale([1.6,1,0.5])
        sphere(3);
        translate([-2,1,0])
        scale([1.5,1,0.5])    
        sphere(2);    
        }    
    }