rTetScrewTop=3.35;
rTetScrew=2.25;
rTetMtrShaft=3;
hTetScrewTop=4;
hTetScrewHeadAndMount=6;

rBearingO=15;
rBearingI=5;
hBearing=10;

rCam=19;
nCamTeeth=9;

tolBearingCam=0.5;
tolCamRing=1;
tolH=0.5;
tolR=0.5;

FN=50;

hCam=hBearing;
//hCam=4;
lCamBump=rCam/nCamTeeth;
thetaCamTeeth=360/nCamTeeth;

r1=rCam;
B=lCamBump;
echo(B);
thet=thetaCamTeeth/4;
rCamBumpO= -(2*r1*r1+B*B+2*r1*B-2*cos(thet)*(r1*r1+r1*B))/(2*(cos(thet)*r1-r1-B));
rCamBumpI=  (2*r1*r1+B*B-2*r1*B-2*cos(thet)*(r1*r1-r1*B))/(2*(cos(thet)*r1-r1+B));


hRing=hCam/2-tolH;
//hRing=4;

rRingO=25.5;
wMount=2;
rMountO=rRingO+wMount+tolR;

hMountBottom=7;
hMountTop=2;


hRingTop=hTetScrewHeadAndMount+hRing;

rTetrixMotorShaft=3;


rRingI=rCam+lCamBump+tolCamRing;
r3=rRingI;

thetR=thetaCamTeeth/4 * nCamTeeth/(nCamTeeth+1);
rRingBumpO= -(2*r3*r3+B*B+2*r3*B-2*cos(thetR)*(r3*r3+r3*B))/(2*(cos(thetR)*r3-r3-B));
rRingBumpI=  (2*r3*r3+B*B-2*r3*B-2*cos(thetR)*(r3*r3-r3*B))/(2*(cos(thetR)*r3-r3+B));

rRingBumpOe= -(2*r3*r3+B*B+2*r3*B-2*cos(thet)*(r3*r3+r3*B))/(2*(cos(thet)*r3-r3-B));
rRingBumpIe=  (2*r3*r3+B*B-2*r3*B-2*cos(thet)*(r3*r3-r3*B))/(2*(cos(thet)*r3-r3+B));


//translate([(rRingI-rCam-tolCamRing),0,0])
shaft();

//mountBottom();

//rotate(180,[0,1,0])
//mountTop();


//translate([0,0,hCam/2])
//ringEqual();

//rotate(180,[0,1,0])
//ringAndHubMount();


//translate([rRingI-rCam-tolCamRing,0,0])
//cam();



//ring();

/*//translate([0,0,hCam/2])
ringEqual();*/

module shaft() {

	translate([0,0,hBearing])
	rotate(180,[1,0,0]) {
	difference() {
		cylinder(h=hBearing, r=rBearingI, $fn=FN);

		translate([-(rRingI-rCam-tolCamRing),0,-0.1])
		cylinder(h=hBearing+0.2, r=rTetrixMotorShaft, $fn=FN);

		translate([-1.75,0,-0.1])
		rotate(135)
		cube([50,50, hBearing+0.3]);
	}

	translate([-(rRingI-rCam-tolCamRing)+rTetrixMotorShaft-0.5,-rTetrixMotorShaft, 3.5])
	cube([rTetrixMotorShaft/2, 2*rTetrixMotorShaft, hBearing-3.5]);

	}

}

module cam() {
	difference() {
	union() {
		// main cam cylinder
		cylinder(h=hCam, r=rCam-B, $fn=FN);

		// cam teeth
		for (i=[0:nCamTeeth]) {
			rotate(360*i/nCamTeeth)
			translate([rCam+lCamBump-rCamBumpO,0,0])
			cylinder(h=hCam, r=rCamBumpO, $fn=FN);
		}
	} // union

		// bearing hole
		translate([0,0,-0.1])
		cylinder(h=hCam+0.2, r=rBearingO+tolBearingCam, $fn=FN);
/*
		// cam teeth indents
		for (i=[0:nCamTeeth]) {
			rotate(360*(i+0.5)/nCamTeeth)
			translate([rCam-lCamBump+rCamBumpI,0,-0.1])
			cylinder(h=hCam+0.2, r=rCamBumpI, $fn=rCam);
		}
*/
	} // diff
}

module ring() {
	difference() {
	union() {
		// main ring cylinder
		cylinder(h=hRing, r=rRingO, $fn=FN);


	} // union

		// ring hole
		translate([0,0,-0.1])
		cylinder(h=hRing+0.2, r=rRingI, $fn=FN);

		// ring teeth indents
		for (i=[0:nCamTeeth]) {
			rotate(360*i/(nCamTeeth+1))
			translate([rRingI+lCamBump-rRingBumpO,0,-0.1])
			cylinder(h=hRing+0.2, r=rRingBumpO, $fn=FN);
		}

	} // diff

		// ring teeth
		for (i=[0:nCamTeeth]) {
			intersection() {
			// main ring cylinder
			cylinder(h=hRing, r=rRingO, $fn=FN);

			rotate(360*(i+0.5)/(nCamTeeth+1))
			translate([rRingI-lCamBump+rRingBumpI,0,0])
			cylinder(h=hRing, r=rRingBumpI, $fn=FN);
			}
		}
}

module ringEqual() {
	difference() {
	union() {
		// main ring cylinder
		cylinder(h=hRing, r=rRingO, $fn=FN);


	} // union

		// ring hole
		translate([0,0,-0.1])
		cylinder(h=hRing+0.2, r=rRingI-B, $fn=FN);

		// ring teeth indents
		for (i=[0:nCamTeeth]) {
			rotate(360*i/(nCamTeeth))
			translate([rCam+lCamBump-rCamBumpO,0,-0.1])
			cylinder(h=hRing+0.2, r=rCamBumpO+B+tolCamRing, $fn=FN);
		}

	} // diff

}

module ringAndHubMount() {

translate([0,0,hCam/2+tolH])
//ringEqual();
ring();

difference() {
		// main ring cylinder
		translate([0,0,hCam])
		intersection() {
			cylinder(h=hTetScrewHeadAndMount, r=rRingO, $fn=FN);

			cylinder(h=hTetScrewHeadAndMount, r2=rRingO-hTetScrewHeadAndMount, 
					r1=rRingO, $fn=FN);
		}

		translate([0,0,hCam-0.1])
		cylinder(h=hTetScrewHeadAndMount+0.2, r=rTetMtrShaft+tolBearingCam, $fn=40);

		for(i=[0:1:3]){
			rotate([0,0,i*90]) {
			translate([8,0,hCam-0.1])
			cylinder(h=hTetScrewTop+0.25 +0.1, r=rTetScrewTop+0.1, 
					$fn=20);

			translate([8,0,hCam-1])
			cylinder(h=6+1 +2, r=rTetScrew+0.1, 
					$fn=20);
			}
		}
}
}

module mountBottom() {

ring();

difference() {
	union() {
	// main mount cylinder
	translate([0, 0, -hMountBottom]) 
	cylinder(h=hMountBottom+hBearing*0.75+2*tolH, r=rMountO, $fn=FN);

	// screw mounts
	translate([-(rMountO+rTetScrewTop+1.35-wMount), 0, -hMountBottom]){
	cylinder(h=hMountBottom+hBearing*0.75+2*tolH, r=rTetScrewTop+1.35, $fn=20);
	translate([0,-(rTetScrewTop+1.35),0])
	cube([(rTetScrewTop+1.35), 2*(rTetScrewTop+1.35), hMountBottom+hBearing*0.75+2*tolH]);
	}

	rotate(120)
	translate([-(rMountO+rTetScrewTop+1.35-wMount), 0, -hMountBottom]){
	cylinder(h=hMountBottom+hBearing*0.75+2*tolH, r=rTetScrewTop+1.35, $fn=20);
	translate([0,-(rTetScrewTop+1.35),0])
	cube([(rTetScrewTop+1.35), 2*(rTetScrewTop+1.35), hMountBottom+hBearing*0.75+2*tolH]);
	}

	rotate(240)
	translate([-(rMountO+rTetScrewTop+1.35-wMount), 0, -hMountBottom]){
	cylinder(h=hMountBottom+hBearing*0.75+2*tolH, r=rTetScrewTop+1.35, $fn=20);
	translate([0,-(rTetScrewTop+1.35),0])
	cube([(rTetScrewTop+1.35), 2*(rTetScrewTop+1.35), hMountBottom+hBearing*0.75+2*tolH]);
	}
	}

	translate([0,0,0.1+hRing])
	cylinder(h=hMountBottom+hBearing*0.75+2*tolH, r=rRingO+tolR, $fn=FN);

	translate([0,0,0.1])
	cylinder(h=hMountBottom+hBearing*0.75+2*tolH, r=rRingO-0.1, $fn=FN);

	// screw holes for sides of mount
	rotate(0)
	translate([-(rMountO+rTetScrewTop+1.35-wMount), 0, -hMountBottom-0.1])
	cylinder(h=hMountBottom+hBearing*0.75+2*tolH+0.2, r=rTetScrew, $fn=20);

	rotate(120)
	translate([-(rMountO+rTetScrewTop+1.35-wMount), 0, -hMountBottom-0.1])
	cylinder(h=hMountBottom+hBearing*0.75+2*tolH+0.2, r=rTetScrew, $fn=20);

	rotate(240)
	translate([-(rMountO+rTetScrewTop+1.35-wMount), 0, -hMountBottom-0.1])
	cylinder(h=hMountBottom+hBearing*0.75+2*tolH+0.2, r=rTetScrew, $fn=20);



// motor shaft bearing
translate([0, 0, -hMountBottom]) 
	translate([0,0,-0.1])
	cylinder(h=hMountBottom+0.3, r=7, $fn=40);

// screwholes, tetrix gearbox
translate([7,14.25,-hMountBottom])
	translate([0,0,-0.1])
	cylinder(h=hMountBottom+0.2, r=4.5/2, $fn=20);
translate([7,14.25,-hMountBottom+2])
	translate([0,0,-0.1])
	cylinder(h=hMountBottom+0.2, r=4, $fn=20);

translate([7,-14.25,-hMountBottom])
	translate([0,0,-0.1])
	cylinder(h=hMountBottom+0.2, r=4.5/2, $fn=20);
translate([7,-14.25,-hMountBottom+2])
	translate([0,0,-0.1])
	cylinder(h=hMountBottom+0.2, r=4, $fn=20);

// screwholes, andymark gearbox
translate([7,0,0])
rotate(60)
{translate([0,31/2,-hMountBottom])
	translate([0,0,-0.1])
	cylinder(h=hMountBottom+0.2, r=4.5/2, $fn=20);
translate([0,31/2,-hMountBottom+2])
	translate([0,0,-0.1])
	cylinder(h=hMountBottom+0.2, r=4, $fn=20);}

translate([7,0,0])
{translate([0,31/2,-hMountBottom])
	translate([0,0,-0.1])
	cylinder(h=hMountBottom+0.2, r=4.5/2, $fn=20);
translate([0,31/2,-hMountBottom+2])
	translate([0,0,-0.1])
	cylinder(h=hMountBottom+0.2, r=4, $fn=20);}
/*
translate([7,0,0])
rotate(-60)
{translate([0,31/2,-hMountBottom])
	translate([0,0,-0.1])
	cylinder(h=hMountBottom+0.2, r=4.5/2, $fn=20);
translate([0,31/2,-hMountBottom+2])
	translate([0,0,-0.1])
	cylinder(h=hMountBottom+0.2, r=4, $fn=20);}*/
/*
translate([7,0,0])
rotate(60)
{translate([0,-31/2,-hMountBottom])
	translate([0,0,-0.1])
	cylinder(h=hMountBottom+0.2, r=4.5/2, $fn=20);
translate([0,-31/2,-hMountBottom+2])
	translate([0,0,-0.1])
	cylinder(h=hMountBottom+0.2, r=4, $fn=20);}
*/
translate([7,0,0])
{translate([0,-31/2,-hMountBottom])
	translate([0,0,-0.1])
	cylinder(h=hMountBottom+0.2, r=4.5/2, $fn=20);
translate([0,-31/2,-hMountBottom+2])
	translate([0,0,-0.1])
	cylinder(h=hMountBottom+0.2, r=4, $fn=20);}

translate([7,0,0])
rotate(-60)
{translate([0,-31/2,-hMountBottom])
	translate([0,0,-0.1])
	cylinder(h=hMountBottom+0.2, r=4.5/2, $fn=20);
translate([0,-31/2,-hMountBottom+2])
	translate([0,0,-0.1])
	cylinder(h=hMountBottom+0.2, r=4, $fn=20);}

} // diff
}

module mountTop() {

intersection() {

	translate([0,0,500/2+hBearing*0.75+2*tolH])
	cube([500,500,500], center=true);

difference() {
	union() {
	// main mount cylinder
	translate([0, 0, -hMountBottom]) 
	cylinder(h=hMountBottom+hBearing+2*tolH+hTetScrewHeadAndMount+hMountTop, r=rMountO, $fn=FN);

	// screw mounts
	for (i=[0:120:240]) {
	rotate(i) 
	translate([-(rMountO+rTetScrewTop+1.35-wMount), 0, -hMountBottom]){
	cylinder(h=hMountBottom+hBearing+2*tolH+hTetScrewHeadAndMount+hMountTop, r=rTetScrewTop+1.35, $fn=20);
	translate([0,-(rTetScrewTop+1.35),0])
	cube([(rTetScrewTop+1.35), 2*(rTetScrewTop+1.35), hMountBottom+hBearing+2*tolH+hTetScrewHeadAndMount+hMountTop]);
	}
	}

	}

	// hub
	translate([0,0,hBearing+2*tolH+hTetScrewHeadAndMount-0.1])
	cylinder(h=2+0.2, r=11+1.5, $fn=40);

	translate([0,0,0])
	cylinder(h=hBearing+2*tolH+hTetScrewHeadAndMount, r=rRingO+tolR, $fn=FN);


	// screw holes for sides of mount

	for (i=[0:120:240]) {
	rotate(i){
	translate([-(rMountO+rTetScrewTop+1.35-wMount), 0, -hMountBottom-0.1])
	cylinder(h=hMountBottom+hBearing+2*tolH+hTetScrewHeadAndMount+hMountTop+0.2, r=rTetScrew, $fn=20);
	translate([-(rMountO+rTetScrewTop+1.35-wMount), 0, hBearing+2*tolH+hTetScrewHeadAndMount+hMountTop-(4+1)])
	cylinder(h=4+1+0.1, r=rTetScrewTop, $fn=20);

	translate([-(rMountO+rTetScrewTop+1.35-wMount), 0, hBearing+2*tolH+hTetScrewHeadAndMount+hMountTop-(4+1)-1])
	cylinder(h=1+0.1, r1=rTetScrew, r2=rTetScrewTop+0.3, $fn=20);
	}
	}

}

} // diff
}

