points = [
    for (x=[100:360]) [ x, sin(x)*20+100 ],
    for (x=[360:-1:0])  [ x, sin(x)*100 ],
];

$fn=50;

difference(){    
hull(){    
    //top sides 
    translate([40,0,-25])
            rotate([0,0,-120])
            scale([1.5,1,0.5])
            sphere(50);
    translate([40,0,25])
            rotate([0,0,-120])
            scale([1.5,1,0.5])
            sphere(50);    

    //tip
    translate([20,-70,0])            
        sphere(25);      

    //basic pattern plate (middle)
    translate([-250,0,0])
        linear_extrude(5){
                difference(){    
                    polygon(points);
                    square(130);
            }
        }
    }
    
    //holes
    translate([10,40,-20])
        color("blue")
        rotate([90,0,-35])
        cylinder(100,20,20);
}
    